---
title: RTCPeerConnection.restartIce()
slug: Web/API/RTCPeerConnection/restartIce
tags:
  - API
  - ICE
  - ICE Restarts
  - Media
  - Method
  - Negotiation
  - RTCPeerConnection
  - Reference
  - Signaling
  - WebRTC
  - WebRTC API
  - restartIce
---
<p>{{APIRef("WebRTC API")}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> API's {{domxref("RTCPeerConnection")}} interface offers the <code><strong>restartIce()</strong></code> method to allow a web application to easily request that {{Glossary("ICE")}} candidate gathering be redone on both ends of the connection.</span> This simplifies the process by allowing the same method to be used by either the caller or the receiver to trigger an ICE restart.</p>

<p>After <code>restartIce()</code> returns, the offer returned by the next call to {{domxref("RTCPeerConnection.createOffer", "createOffer()")}} is automatically configured to trigger ICE restart on both the local peer (once the local peer has been set) and on the remote peer, once the offer is sent across your signaling mechanism and the remote peer has set its description as well.</p>

<p><code>restartIce()</code> causes the {{domxref("RTCPeerConnection.negotiationneeded_event", "negotiationneeded")}} event to be fired on the <code>RTCPeerConnection</code> to inform the application that it should perform negotiation using its signaling channel.</p>

<p>If negotiation fails to complete—either due to rollback or because incoming offers are in the process of being negotiated—the {{domxref("RTCPeerConnection")}} will remember that you requested ICE restart. The next time the connection's {{domxref("RTCPeerConnection.signalingState", "signalingState")}} changes to <code>stable</code>, the connection will fire the {{domxref("RTCPeerConnection.negotiationneeded_event", "negotiationneeded")}} event. This process continues until an ICE restart has been successfully completed.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtcPeerConnection</em>.restartIce();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>After calling <code>restartIce()</code>, the next offer created using {{domxref("RTCPeerConnection.createOffer", "createOffer()")}} will initiate ICE restart once sent to the remote peer over your signaling mechanism. Restarting ICE essentially resets ICE so that it creates all new candidates using new credentials. Existing media transmissions continue uninterrupted during this process.</p>

<p>For details about how ICE restart works, see {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Session_lifetime", "ICE restart")}} and {{RFC(5245, "ICE specification", "9.1.1.1")}}.</p>

<h2 id="Example">Example</h2>

<p>This example creates a handler for the {{domxref("RTCPeerConnection.iceconnectionstatechange_event", "iceconnectionstatechange")}} event that handles a transition to the <code>failed</code> state by restarting ICE in order to try again.</p>

<pre class="brush: js">pc.addEventListener("iceconnectionstatechange", event =&gt; {
  if (pc.iceConnectionState === "failed") {
    /* possibly reconfigure the connection in some way here */
    /* then request ICE restart */
    pc.restartIce();
  }
});
</pre>

<p>With this code in place, a transition to the <code>failed</code> state during ICE negotiation will cause a {{domxref("RTCPeerConnection.negotiationneeded_event", "negotiationneeded")}} event to be fired, in response to which your code should renegotiate as usual. However, because you have called <code>restartIce()</code>, your call to {{domxref("RTCPeerConnection.createOffer", "createOffer()")}} which occurs in the handler for <code>negotiationneeded</code> will trigger an ICE restart rather than just a regular renegotiation.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-restartice', 'RTCPeerConnection.restartIce()')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.restartIce")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a></li>
</ul>
